"use strict";

this.name    = "VimanaAlerts";
this.version = "1.00";
this.author  = "Gnievmir";
this.license = "CC-BY-NC-SA 3.0";

this.$AlertTimer = null;		//store pointer to graphical info timer
this.$LastAlert = [];
this.$IncomingMiss = false;		//incoming missiles flag

this.$Alerts = [
	  "clean.png",			 //0 -no alert
	  "d_missile.png",		 //1 
	  "d_altitude.png",		 //2
	  "d_temp.png",	         //3
	  "d_energy.png",	     //4 
	  "d_shield.png",	     //5 
	  "w_energy.png",		 //6
	  "w_shield.png",		 //7
	  "w_temp.png"		     //8 
];

this.startUp = function() {
 //log(this.name, player.ship.dials); 
}

this.shipAttackedWithMissile = function(missile,whom){
  this.$IncomingMiss = true;
  if(this.$LastAlert[0] != 1)this.$LastAlert[0] = -1;
  this._display(1);
}

this.shipWillLaunchFromStation = function() {
    if(!this.$AlertTimer) this.$AlertTimer = new Timer(this, this._alerts.bind(this), 0, 1);
    this._resetAlerts();
}

this.shipWillDockWithStation = function() {
  var p = player.ship;
  if(this.$AlertTimer) {
    this.$AlertTimer.stop();
    delete this.$AlertTimer;
  }
  p.setCustomHUDDial("VimanaAlert",this.$Alerts[0]); 
}

this.shipDied = function(whom, why)
{
    this.shipWillDockWithStation();
}

this._resetAlerts = function(){
    for (let i = 1;i < 5;i++){
        this.$LastAlert[i] = 100000;
    }
    this.$LastAlert[5] = 0;
}

this._alerts = function(){
  var p = player.ship;
  var ano = 0;
  //check incoming missile
  if(this.$IncomingMiss){
    if (player && p){	
      var miss = system.entitiesWithScanClass("CLASS_MISSILE",p,25600);
      for (let i = 0;i < miss.length;i++){
	if(miss[i].target == p){
	  this._display(1);
	  this.$IncomingMiss = true;
	  return;
	}else{ 	// No incoming missiles
	  this.$IncomingMiss = false;
	}
      }
    }
  }
    //calculate altitude
  var ss = system.sun; 
  var alt = 0; 
  var sp = system.planets;
  var len = sp.length;
  var ctmp = Math.round(100*p.temperature);
  
  if(!system.isInterstellarSpace){
    if(ss)var d = p.position.distanceTo( ss.position ); 
    else var d = 100000000000000000000.0; 

    for(let i=0;i< len;i++){
        var s = p.position.distanceTo( sp[i].position )-sp[i].radius;
        if(d > s) {
        d = s;
        ss = sp[i];
        }
    }
    if(ss) alt = p.position.distanceTo(ss) - ss.radius - p.collisionRadius;
  }else{
      alt = 999999;
  }
  
  if(p.energy < p.maxEnergy/3 && p.energy < this.$LastAlert[1]){
      ano = 4;
      this.$LastAlert[1] = p.energy;
  }else if(p.forwardShield < p.maxForwardShield * 0.2 && p.forwardShield < this.$LastAlert[2]){
      ano = 5; 
      this.$LastAlert[2] = p.forwardShield;
  }else if(p.aftShield < p.maxAftShield * 0.2 && p.aftShield < this.$LastAlert[3]){
      ano = 5;
      this.$LastAlert[3] = p.aftShield;
  }else if(alt < 10000 && alt < this.$LastAlert[4]){
      ano = 2;
      this.$LastAlert[4] = alt;
  }else if(ctmp > 70 && ctmp > this.$LastAlert[5]){
      ano = 3;
      this.$LastAlert[5] = ctmp;
  }else if(p.energy < p.maxEnergy/2 && p.energy < this.$LastAlert[1]){
      ano = 6;
      this.$LastAlert[1] = p.energy;
  }else if(p.forwardShield < p.maxForwardShield/2 && p.forwardShield < this.$LastAlert[2]){
      ano = 7;
      this.$LastAlert[2] = p.forwardShield;
  }else if(p.aftShield < p.maxAftShield/2 && p.aftShield < this.$LastAlert[3]){
      ano = 7;
      this.$LastAlert[3] = p.aftShield;
  }else if(ctmp>50 && ctmp > this.$LastAlert[5]){
      ano = 8;
      this.$LastAlert[5] = ctmp;
  }
  this._display(ano);
}

this._display = function(a){
  if(a == 0 && a == this.$LastAlert[0]) { this._resetAlerts(); return; }

  var p = player.ship;
  if(a > 0){ //alerts
    var seq = Math.floor((this.$AlertTimer.nextTime)%3);
    if(seq < 2 ) p.setCustomHUDDial("VimanaAlert",this.$Alerts[a]);
    else p.setCustomHUDDial("VimanaAlert",this.$Alerts[0]);
  }else{
    p.setCustomHUDDial("VimanaAlert",this.$Alerts[0]);
  }
  this.$LastAlert[0] = a;
}
